Bug 1125953 - Review Request: pyscard - Python smartcard library
Summary: Review Request: pyscard - Python smartcard library
Keywords:
Status: CLOSED NEXTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Jerry James
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
: 663102 (view as bug list)
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2014-08-01 12:30 UTC by Nikos Mavrogiannopoulos
Modified: 2014-08-11 12:45 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2014-08-11 12:45:37 UTC
loganjerry: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Nikos Mavrogiannopoulos 2014-08-01 12:30:25 UTC
Spec URL: http://people.redhat.com/nmavrogi/fedora/pyscard.spec
SRPM URL: http://people.redhat.com/nmavrogi/fedora/pyscard-1.6.16-1.fc20.src.rpm
Description: The pyscard smartcard library is a framework for building smart card aware applications in Python. The smartcard module is built on top of the PCSC API Python wrapper module.
Fedora Account System Username: nmav

Comment 1 Nikos Mavrogiannopoulos 2014-08-01 12:31:02 UTC
*** Bug 663102 has been marked as a duplicate of this bug. ***

Comment 2 Jerry James 2014-08-06 17:31:43 UTC
MUST issues, in no particular order:
1. Sources used to build the package do not match the upstream source, as
   provided in the spec URL.
   See: http://fedoraproject.org/wiki/Packaging/SourceURL
2. Permissions on %{python_sitearch}/smartcard/scard/_scard.so are 0775
   instead of 0755.
   See: http://fedoraproject.org/wiki/Packaging/Guidelines#FilePermissions
3. In multiple licensing scenarios, the package must contain a comment
   explaining the license breakdown.  See:
   https://fedoraproject.org/wiki/Packaging:LicensingGuidelines#Multiple_Licensing_Scenarios
   In this case, it appears that smartcard/Observer.py and
   smartcard/Synchronization.py are CC-BY-SA, smartcard/ClassLoader.py is
   Python, and everything else is LGPLv2+.  Note also that the spec file does
   not use the correct license names.  It should read:

   LGPLv2+ and Python and CC-BY-SA

   See: https://fedoraproject.org/wiki/Licensing:Main?rd=Licensing
4. The %files section contains a %defattr declaration, which is not needed on
   any current Fedora or EPEL release.  (It is only needed for rpm versions
   prior to 4.4; RHEL 5.10 has rpm 4.4.2.3.)

SHOULD issues, in no particular order:
5. I question the usefulness of including PKG-INFO in %doc.  It is already
   installed where it is useful, as the python egg (i.e., it is installed as
   %{python_sitearch}/pyscard-1.6.16-py2.7.egg-info.
6. Speaking of %doc, would the contents of smartcard/doc be suitable?  They
   are not currently installed in the package.
7. Since an effort is currently underway to convert packages to the new
   %license tag, you may as well move LICENSE from %doc to %license.
8. This package uses the old filtering scheme.  The new one is described here:
   http://fedoraproject.org/wiki/Packaging:AutoProvidesAndRequiresFiltering

   In this case, the filter could be expressed as:

   %global __provides_exclude_from ^%{python_sitearch}/.*\\.so$

   But even that is not needed on Fedora 20 or later, where rpm already
   filters out such .so files; see https://fedorahosted.org/fpc/ticket/353.
9. Is there any possibility of adding a %check section that runs some or all
   of the tests in smartcard/test?


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[!]: If the package is under multiple licenses, the licensing breakdown must
     be documented in the spec.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[!]: Each %files section contains %defattr if rpm < 4.4
     Note: %defattr present but not needed
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 51200 bytes in 3 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: pyscard-1.6.16-1.fc22.x86_64.rpm
          pyscard-1.6.16-1.fc22.src.rpm
pyscard.x86_64: W: invalid-license PSF
pyscard.x86_64: W: invalid-license CC BY-SA 3.0
pyscard.x86_64: E: non-standard-executable-perm /usr/lib64/python2.7/site-packages/smartcard/scard/_scard.so 0775L
pyscard.src: W: spelling-error %description -l en_US smartcard -> smart card, smart-card, MasterCard
pyscard.src: W: invalid-license PSF
pyscard.src: W: invalid-license CC BY-SA 3.0
pyscard.src: W: file-size-mismatch pyscard-1.6.16.tar.gz = 186253, http://ludovic.rousseau.free.fr/softwares/pcsc-lite/pyscard-1.6.16.tar.gz = 186223
2 packages and 0 specfiles checked; 1 errors, 6 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint pyscard
pyscard.x86_64: W: invalid-license PSF
pyscard.x86_64: W: invalid-license CC BY-SA 3.0
pyscard.x86_64: E: non-standard-executable-perm /usr/lib64/python2.7/site-packages/smartcard/scard/_scard.so 0775L
1 packages and 0 specfiles checked; 1 errors, 2 warnings.
# echo 'rpmlint-done:'



Requires
--------
pyscard (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libpthread.so.0()(64bit)
    libpython2.7.so.1.0()(64bit)
    pcsc-lite
    python(abi)
    rtld(GNU_HASH)



Provides
--------
pyscard:
    pyscard
    pyscard(x86-64)



Unversioned so-files
--------------------
pyscard: /usr/lib64/python2.7/site-packages/smartcard/scard/_scard.so

Source checksums
----------------
http://ludovic.rousseau.free.fr/softwares/pcsc-lite/pyscard-1.6.16.tar.gz :
  CHECKSUM(SHA256) this package     : bd9f39fe5e6500c9578edfc616cc4d213e952f49eb444b41e2a1978fc270eaac
  CHECKSUM(SHA256) upstream package : ec8c45fd18f6d4e2d98a4ebae4dde444bcd727eb4d940cd3d3e65a866338a3ee
diff -r also reports differences


Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review -b 1125953 -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, Generic, Shell-api, C/C++
Disabled plugins: Java, SugarActivity, fonts, Haskell, Ocaml, Perl, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG

Comment 3 Nikos Mavrogiannopoulos 2014-08-07 13:04:24 UTC
Hello, I believe I've addressed all the comments (except the check yet). The updated spec and srpm are at:
http://people.redhat.com/nmavrogi/fedora/pyscard-1.6.16-2.fc20.src.rpm
http://people.redhat.com/nmavrogi/fedora/pyscard.spec

Comment 4 Jerry James 2014-08-07 20:19:11 UTC
Number 1 does not appear to be addressed.  The upstream tarball, http://ludovic.rousseau.free.fr/softwares/pcsc-lite/pyscard-1.6.16.tar.gz, is 186223 bytes and has a SHA256 checksum of ec8c45fd18f6d4e2d98a4ebae4dde444bcd727eb4d940cd3d3e65a866338a3ee.  The tarball in your source RPM is 186253 bytes and has a SHA256 checksum of bd9f39fe5e6500c9578edfc616cc4d213e952f49eb444b41e2a1978fc270eaac.  Why the difference?

Number 3 was not quite fixed all the way.  The name to use on the "License:" line is "CC-BY-SA", not "CC BY-SA 3.0".  When in doubt about the proper name of a license, please consult the tables of licenses on this page: https://fedoraproject.org/wiki/Licensing:Main?rd=Licensing.

Otherwise the package looks good.

Comment 5 Nikos Mavrogiannopoulos 2014-08-08 07:23:38 UTC
(In reply to Jerry James from comment #4)
> Number 1 does not appear to be addressed.  The upstream tarball,
> http://ludovic.rousseau.free.fr/softwares/pcsc-lite/pyscard-1.6.16.tar.gz,
> is 186223 bytes and has a SHA256 checksum of
> ec8c45fd18f6d4e2d98a4ebae4dde444bcd727eb4d940cd3d3e65a866338a3ee.  The
> tarball in your source RPM is 186253 bytes and has a SHA256 checksum of
> bd9f39fe5e6500c9578edfc616cc4d213e952f49eb444b41e2a1978fc270eaac.  Why the
> difference?

Ok I didn't understand that this was your point. I thought you were referring to the fact that this is an unofficial release. I checked the differences and it seems that upstream has updated the 1.6.16 tarball by adding clarifications to licenses.

> Number 3 was not quite fixed all the way.  The name to use on the "License:"
> line is "CC-BY-SA", not "CC BY-SA 3.0". 

Updated.

I've updated the srpm and the spec under the same URLs (-2) as above.

Comment 6 Jerry James 2014-08-08 15:56:50 UTC
Okay, that fixes all of the issues.  This package is APPROVED.

Comment 7 Nikos Mavrogiannopoulos 2014-08-08 20:17:38 UTC
New Package SCM Request
=======================
Package Name: pyscard
Short Description: Python smartcard library
Upstream URL: http://ludovicrousseau.blogspot.cz/2014/07/pyscard-unofficial-version-1616.html
Owners: nmav
Branches: f21 f20 epel7
InitialCC:

Comment 8 Gwyn Ciesla 2014-08-11 12:36:02 UTC
Git done (by process-git-requests).


Note You need to log in before you can comment on or make changes to this bug.